#!/usr/bin/perl

my(%cgi,%cookie,%Template,%cache,%Index);

require 'jcode.pl';
require 'yapw.conf';

# yapw.cgi is modal:
#  index, view, edit, set sign, write, rewrite, and more

%cgi    = GETQuery();
%cookie = GETCookie();

$target = $ENV{PATH_INFO};
$target =~s/^\///;
if(defined $ENV{PATH_INFO}){
    mode_setsign($cgi{setsign}) if defined $cgi{setsign};
    mode_edit($target)    if defined $cgi{edit};
    mode_rewrite($target) if defined $cgi{rewrite};
    mode_view($target);
}
mode_setsign($cgi{setsign}) if defined $cgi{setsign};
mode_write($cgi{write})     if defined $cgi{write};

# anything else
mode_index();
exit(0);

# each mode functions 
#   / call from yapw.cgi

sub mode_index{
    print httpHead();
    print makeIndex();
    exit(0);
}

sub mode_view{
    my($target) = @_;
    existcheck($target);
    print httpHead();
    print makeView($target);
    exit(0);
}

sub mode_setsign{
    my($sign) = @_;
    $sign = $cgi{setsign};
    $cookie{yapwsign} = $sign;
    print setCookie("yapwsign",$sign);
    $SETSIGN = "Sign Seted";
}

sub mode_edit{
    my($target) = @_;
    existcheck($target);
    print httpHead();
    print makeEdit($target);
    exit(0);
}

sub mode_write{
    my($target) = @_;
    my($newsource) = $cgi{text};
    existcheck($target);
    $oldsource = readSource($target,'scalar');
    $newsource = staticAlias($newsource);
    addRindex($target,$oldsource,$newsource);
    addSource($target,$newsource);
    print redirect($target);
    exit(0);
}

sub mode_rewrite{
    my($target) = @_;
    my($newsource) = $cgi{text};
    my(@temp);
    existcheck($target);
    $oldsource = readSource($target,'scalar');
    $newsource = staticAlias($newsource);
    addRindex($target,$oldsource,$newsource);
    dropRindex($target,$oldsource,$newsource);
    renewSource($target,$newsource);
    print redirect($target);
    exit(0);
}

sub existcheck($target){
    my($target) = @_;
    my($filename,@temp);
    $filename = filenameEncode($target);
    if(!(-e "$sourceDIR/$target")){
	open(INIT,">$sourceDIR/$filename") or die "$sourceDIR/$filename";
	close(INIT);
	chmod(0666,"$sourceDIR/$filename") if($able_suexec ne 'yes');
    }
    if(!(-e "$rindexDIR/$filename")){
    	open(INIT,">$rindexDIR/$filename") or die "$rindexDIR/$filename";
	close(INIT);
	chmod(0666,"$rindexDIR/$filename") if($able_suexec ne 'yes');
	@temp = searchWord($target);
	makeRindex($target,\@temp);
    }
}

sub redirect{
    my($target) = @_;
    my($filename);
    if($target eq ''){
	print "Location: http://$server$CGIpath\n\n";
    }else{
	$filename = URLencode($target);
	print "Location: http://$server$CGIpath/$filename\n\n";
    }
}

#
# Usual Fuctions for HTTP
#

sub setCookie{
    my($name,$value,@option) = @_;
    my($result,@day,@month);

    @day = ("Sun","Mon","Tue","Wed",
	    "Thu","Fri","Sat");
    @month = ("","Jan","Feb","Mar","Apr","May","Jun",
	      "Jul","Aug","Sep","Oct","Nov","Dec");
    local($sec,$min,$hour,$day,$month,$year,$wday,$yday,$dst)
        = gmtime(time + 365 * 24 * 60 * 60);
    $month++;$year += 1900;
    $dateMes = 
        sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT"
                ,$day[$wday]
                ,$day,$month[$month],$year
                ,$hour,$minute,$second);
    $result .= "Set-cookie: $name=$value; path=$CGIpath; expires=$dateMes;\n";
    return $result;
}

sub URLencode{
#ARG = $plain | RETURNS = $encoded;
    local($_) = @_;
    s/(\W)/sprintf("%%%02X",unpack("C", $1))/eg;
    return $_;
}

sub URLdecode{
#ARG = $encoded | RETURNS = $plain;
    local($_) = @_;
    s/\%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
    return $_;
}

sub filenameEncode{
    local($_) = @_;
    s/[\/\-\*\%]/sprintf("%%%02X",unpack("C", $1))/eg;
    s/^[\<\>\.]/sprintf("%%%02X",unpack("C", $1))/eg;
    return $_;
}

sub filenameDecode{
    local($_) = @_;
    s/\%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
    return $_;
}

sub GETCookie{
#ARG = () | RETURNS = %cookie;
    my(%cookie,$line,$name,$value);
    foreach $line (split(/;\s*/,$ENV{HTTP_COOKIE})){
	($name,$value) = split(/=/,$line);
	$value = URLdecode($value);
	$cookie{$name} = $value;
    }
    return %cookie;
}

sub GETQuery{
#ARG = () | RETURNS = %cgi_query;
    my(%cgi,$str,$i,$name,$value);

    if($ENV{REQUEST_METHOD} eq "GET"){
	$str = $ENV{QUERY_STRING};	
    }else{	
	read(STDIN,$str,$ENV{'CONTENT_LENGTH'});
    }

    if($str =~ /=/){
	foreach $i (split('&',$str)){
	    ($name,$value) = split('=',$i);
	    $value =~ tr/+/ /;
	    $value = URLdecode($value);
	    &jcode::convert(*value,'euc');
	    $value =~ s/\015\012/\012/g;
	    $value =~ s/\015/\012/g;
	    $cgi{$name} = $value;
	}
    }else{
	$cgi{$str} = 1;
    }
    return %cgi;
    
}

sub httpHead{
    my($resurt);
    $result .= "Content-type: text/html\r\n";
    $result .= "\r\n";
    return $result;
}

sub getSign{
    $cookie{yapwsign} = $anonysign if($cookie{yapwsign} =~ /^\s*$/);
    return $cookie{yapwsign};
}

sub makeIndex{
# ARG = () | RETURNS = $index;
    my(@Index);
    my($Template,$content,$filename,$result,$moddate,$time,$line);
    local($_);
    $Template = readTemplate("Index");
    $Template = &dynamicAlias($Template);

    @Index = readIndex('array');
    $content  = "<ul>\n";
    foreach $line(@Index){
	$filename = filenameEncode($line);
	$time = Timestamp($line);
	my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdist)
	    =localtime($time);
	$moddate = sprintf("%04d/%02d/%02d %02d:%02d"
			   ,$year,++$mon,$mday,$hour,$min);
	$filename = URLencode($line);
	$content .= "<li>[$moddate]<a href='$CGIpath/$filename?time=$time'>$line</a></li>\n";
    }
    $content .= "</ul>\n";

# commit
    return &resolveTemplate($Template,$content);
}

sub makeView{
    my($subject) = @_;
    my(@Index,%Index,@buffer,$Template,$line,$filename,$paragraph);
    $Template = readTemplate(BBS);
    %Index    = readIndex();
    @Index    = sort {length($a) <=> length($b);} keys %Index;
    @content  = readSource($subject);
    
    foreach $line (@content){
	if($line =~ /^\s*$/){
	    if(defined $paragraph){
	        $content .= &plain2paragraph($paragraph);
	        undef($paragraph);
	    }
	}else{
	    $paragraph .= $line."\n";
	}
    }$content  .= plain2paragraph($paragraph);

    $content = &dynamicAlias($content);
    $content = &quoteHTMLLink(\@buffer,$content);
    $content = &quoteHTMLElem(\@buffer,$content);
    $content = &WikiLink($content);
    $content = &quoteHTMLLink(\@buffer,$content);
    $content = &quoteHTMLchars(\@buffer,$content);
    $content = &unquoteHTML(\@buffer,$content);
    $content =~ s/\\\%sign\%/\%sign\%/mg;
    $filename = URLencode($subject);

# commit new HTML
    return &resolveTemplate($Template,$content,$subject);
}

sub makeEdit{
    my($subject) = @_;
    my($Template,$content);
    $Template = &readTemplate(ReEdit);
    $content  = &readSource($subject,'scalar');
    $content  =~ s{\&}{\&amp;}g;
    $filename = URLencode($subject);
    return &resolveTemplate($Template,$content,$subject);
}
    
sub readIndex{
#ARG = ($mode) | RETURNS = (%Index);
# Index (List of Subject) is Filelist of SourceDIR
    my(@mode) = @_;
    my($entry,$Index,%flag);
    my(%Index);
    foreach $entry (@mode){
	$flag{'force'}  = 1 if($entry eq 'force');
	$flag{'return'} = 'hash'  if($entry eq 'hash');
	$flag{'return'} = 'array' if($entry eq 'array');
    }
    if((! defined $cache{Index}) || defined $flag{'force'}){
	opendir(DIR,"$sourceDIR/") or die "$sourceDIR/";
	while($entry = readdir(DIR)){
	    $entry = filenameDecode($entry);
	    $Index{$entry} = 1;
	}
	closedir(DIR);
	delete $Index{"."};
	delete $Index{".."};
	$cache{Index} = \%Index;
    }
    $Index = $cache{Index};
    if($flag{"return"} eq 'array'){
	local(@Index);
	@Index = sort keys %$Index;
	return @Index;
    }else{
	return %$Index;
    }
}

sub makeFindex{
#ARG = ($content) | RETURNS = (@FindexLIST);
    my($content) = @_;
    my(@Index,$key,$qkey,@FIndex);
    @Index = readIndex("array");
    foreach $key (@Index){
	$qkey = quotemeta($key);
	push(@FIndex,$key) if($content =~ /$qkey/);
    }
    return @FIndex;
}

sub compareFindex{
#ARG = (\@FindexLIST1,\@FindexLIST2) | RETURNS = @diffLIST;
# only returns entry defined in LIST1, but not defined in LIST2.
    my($NEWFindex,$OLDFindex) = @_;
    my($line,@diffLIST,%OLDFindex);
    foreach(@$OLDFindex){
	$OLDFindex{$_} = 1;
    }
    foreach $line(@$NEWFindex){
	push(@diffLIST,$line) if not defined $OLDFindex{$line};
    }
    return @diffLIST;}

sub readRindex{
#ARG = $subject | RETURNS = @RindexLIST;// without postfix
    my($target) = @_;
    my($filename,@result);
    $filename = filenameEncode($target);
    open(FILE,"$rindexDIR/$filename") or die "$rindexDIR/$filename";
    @result = <FILE>;
    close(FILE);
    map {s/\n//;} @result;
    return sort @result;
}

sub makeRindex{
#ARG = $subject,@RindexLIST | RETURNS = ();// without postfix
    local($target,$Rindex) = @_;
    local($_,$filename);
    $_        = join("\n",@$Rindex);
    $filename = filenameEncode($target);
    open(RINDEX, "> $rindexDIR/$filename") or die "$rindexDIR/$filename" ;
    print RINDEX $_."\n";
    close(RINDEX);
}

sub addRindex{
#ARG = ($referer,$oldsource,$newsource) | RETURNS = () | EFFECTS renew Rindexs;
    my($referer,$oldsource,$newsource) = @_;
    my(@oldIndex,@newIndex,@targetLIST,$filename,$subject);
    @oldIndex   = makeFindex($oldsource);
    @newIndex   = makeFindex($newsource);
    @targetLIST = compareFindex(\@newIndex,\@oldIndex);
    foreach $subject(@targetLIST){
	$filename = filenameEncode($subject);
	open(RINDEX, ">> $rindexDIR/$filename") or die "$rindexDIR/$filename";
	print RINDEX "$referer\n";
	close(RINDEX);
    }
}

sub dropRindex{
#ARG = ($referer,$oldsource,$newsource) | RETURNS = () | EFFECTS renew Rindexs;
    my($referer,$oldsource,$newsource) = @_;
    my(@oldIndex,@newIndex,@targetLIST,@content,$filename,$subject,$line);
    @oldIndex   = makeFindex($oldsource);
    @newIndex   = makeFindex($newsource);
    @targetLIST = compareFindex(\@oldIndex,\@newIndex);
    foreach $subject(@targetLIST){
	@content = readRindex($subject);
	chomp(@content);
	$filename = filenameEncode($subject);
	open(RINDEX,"> $rindexDIR/$filename") or die "$rindexDIR/$filename";
	foreach $line(@content){
	    print RINDEX "$line\n" unless ($line eq $referer);
	}
	close(RINDEX);
    }
}

sub searchWord{
    local($key) = @_;
    local($_,$qkey,@Index,@result,@content);
    @Index = readIndex('array');
    $qkey = quotemeta($key);
    foreach $subject (@Index){
	@content = readSource($subject);
	$_       = join('',@content);
	push(@result,$subject) if(/$qkey/);
    }
    return @result;
}

sub Timestamp{
    my($target) = @_;
    my($filename);
    $filename = filenameEncode($target);
    return (stat("$sourceDIR/$filename"))[9];
}

sub WikiLink{
    my($content) = @_;
    my(%Index,@Index,$qkey,$i);
    %Index = &readIndex();
    @Index = sort {length($b) <=> length($a)} keys %Index;
    $i = 0;
    while($qkey = quotemeta($Index[$i])){
	$content =~ s/$qkey/\#\#\#REF$i\#\#\#/mg;
	$i++;
    }
    $i = 0;
    $content =~ s{\#\#\#REF(\d+)\#\#\#}{"<a href='$CGIpath/".&URLencode($Index[$1])."?time=".&Timestamp($Index[$1])."'>$Index[$1]</a>"}eg;
    return $content;
}

sub plain2paragraph{
    local($_) = @_;
    my($result,@paragraph);
    
    @paragraph = split(/(?=<p.*?>)/,$_);
    while(@paragraph){
	$_ = shift(@paragraph);
	next if m/^\s*$/;
	$_ = "\n<p>".$_ if not m{^\s*<p.*?>}i;
	if(m{</p>}){
	    s{</p>(.*)}{</p>};
	    unshift(@paragraph,$1);
	}else{
	    $_ .= "</p>\n";
	}
	s{\n}{<br />\n}mg;
	s{</p>\n*<br />}{</p>}g;
	s{<br />\n*</p>}{</p>}g;
	s/^\s*<br \/>$//mg;
	$result .= $_;
    }
    return $result;
}

sub readSource{
#ARG = $subject | RETURNS = @content;// without postfix
    my($target,$mode) = @_;
    my($filiename,@result);
    $filename = filenameEncode($target);
    open(FILE,"$sourceDIR/$filename") or die "$sourceDIR/$filename";
    @result = <FILE>;
    close(FILE);
    map{s/\n//;} @result;
    if($mode eq 'scalar'){
	return join("\n",@result);
    }else{
	return @result;
    }
}

sub addSource{
#ARG = $subject,@content | RETURNS = () | EFFECTS SOURCE
    local($target,$newsource) = @_;
    local($filename);
    $filename = filenameEncode($target);
    open(FILE,">> $sourceDIR/$filename") or die "$sourceDIR/$filename";
    print FILE "\n";
    print FILE $newsource;
    print FILE "\n";
    close(FILE);
}

sub renewSource{
#ARG = $subject,@content | RETURNS = () | EFFECTS SOURCE
    local($target,$newsource) = @_;
    local($filename);
    $filename = filenameEncode($target);
    open(FILE,"> $sourceDIR/$filename") or die "$sourceDIR/$filename";
    print FILE $newsource;
    close(FILE);
}

sub readTemplate{
#ARG = $templateName | RETURNS $Template;
#  %Template cashes Template files.
    my($label) = @_;
    my(@Template);
    if(not defined $TemplateCache{$label}){
	open(FILE,$TemplateFILE{$label});
	@Template = <FILE>;
	close(FILE);
	$TemplateCache{$label} = join('',@Template);
    }
    return $TemplateCache{$label};
}

sub quoteHTMLLink{
    local($buffer,$_) = @_;
    while(s{(<a.*?>.*?</a.*?>)}{"\#\#\#".scalar(@$buffer)."\#\#\#"}ei){
	push(@$buffer,$1);
    }
    return $_;
}

sub quoteHTMLElem{
    local($buffer,$_) = @_;
    while(s{(<($enableElems)(\s+.*?){0,1}>)}{"\#\#\#".scalar(@$buffer)."\#\#\#"}ei){
	push(@$buffer,$1);
    }
    while(s{(</($enableElems)(\s+.*?){0,1}>)}{"\#\#\#".scalar(@$buffer)."\#\#\#"}ei){
	push(@$buffer,$1);
    }
    return $_;
}

sub quoteHTMLchars{
    local($buffer,$_) = @_;
    s{<}{&lt;}g;
    s{>}{&gt;}g;
    return $_;
}

sub unquoteHTML{
    local($buffer,$_) = @_;
    s{\#\#\#(\d+)\#\#\#}{$$buffer[$1]}g;
    return $_;
}

sub HTMLfilter{
#ARG = $string | RETURNS $string;
# replace '<' & '>' without used for enabled tag.
    my(@replaceList,$count);
    $count = 0;
    map {
	while(s{(<($enableElems).*?>)}{\#\#\#$count\#\#\#}i){
	    $replaceList[$count] = $1;
	    $count++;
	}
	while(s{(</($enableElems)>)}{\#\#\#$count\#\#\#}i){
	    $replaceList[$count] = $1;
	    $count++;
	}
	s{<}{&lt;}g;
	s{>}{&gt;}g;
	
	$count = 0;
	
	s{\#\#\#(\d)\#\#\#}{$replaceList[$1]}g;
    } @_;
    return @_;
}

sub staticAlias{
#ARG = ($source) | RETURNS = ($source);
    my($source) = @_;
    $source =~ s/\\\%/\#\#\#\\\%\#\#\#/mg;
    $source =~ s/\%sign\%/&doSign();/eg;
    $source =~ s/\#\#\#\\\%\#\#\#/\\\%/mg;
    return $source;
}

sub dynamicAlias{
    my($source) = @_;
    $source =~ s/\\\%/\#\#\#\\\%\#\#\#/mg;
    $source =~ s/\%sign\%/&getSign();/eg;
    $source =~ s/\%YaPWsource\%/&showCGISource();/eg;
    $source =~ s/\#\#\#\\\%\#\#\#/\\\%/mg;
    return $source;
}

sub resolveTemplate{
    my($Template,$content,$subject) = @_;
    $Template =~ s/\\\%/\#\#\#\\\%\#\#\#/mg;
    $Template =~ s/\%sign\%/&getSign();/eg;
    $Template =~ s{\%baseURL\%}{http://$server$HTTPDIR}g;
    $Template =~ s{\%cgiURL\%}{http://$server$CGIpath}g;
    $Template =~ s{\%subject\%}{$subject}g;
    $Template =~ s{\%pathinfo\%}{&URLencode($subject)}eg;
    $Template =~ s{\%rindex\%}{&showRindex($subject);}eg;
    $Template =~ s{\%content\%}{$content}g;
    $Template =~ s/\#\#\#\\\%\#\#\#/\%/mg;
    return $Template;
}


sub doSign{
#ARG = () | RETURNS = ($date_and_sign);
    my($SIGN,$sign,$date);
    $sign             = getSign()  if(defined $cgi{addsign});
    if(defined $cgi{adddate}){
	my($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdist)
	    =localtime(time);$mon++;$year += 1900;
	$date = sprintf("%04d/%02d/%02d %02d:%02d"
			,$year,$mon,$day,$hour,$min);
    }
    $SIGN = "<span class='signature'>--$date $sign<\/span>" if($sign || $date);
    return $SIGN;
}

sub showCGISource{
#ARG = () | RETURNS = ($content_of_'this'_script);
    my(@source,$source);
    open(THIS,"$ENV{SCRIPT_FILENAME}");
    @source = <THIS>;
    close(THIS);
    $source = join('',@source);
    $source =~ s{<}{&lt;}g;
    $source =~ s{>}{&gt;}g;
    return "<pre>\n".$source."</pre>\n";
}

sub showRindex{
# prepare Rindex
    my($target) = @_;
    my($line,$filename,$timestamp,$Rindex,@Rindex);
    @Rindex   = readRindex($target);
    $Rindex .= "\n";
    foreach $line(@Rindex){
	next if($line =~ /^\s*$/);
	next if($line eq $target);
	$filename  = URLencode($line);
	$timestamp = Timestamp($line);
	$Rindex  .= "<a href='$CGIpath/$filename?time=$timestamp'>$line</a>\n";
    }
    return $Rindex;
}
